
#include "ti83plus.inc"
#include "mirage.inc"
#DEFINE kDown   01h
#DEFINE kLeft   02h
#DEFINE kRight  03h
#DEFINE kUp     04h
#define k2nd       223
#define kMode   191
#define kDel   127
#define equ .equ
#define EQU .equ
#define xmm savesscreen+2
#define ymm savesscreen+3
#define prite savesscreen+4
#define back savesscreen+5
#define spd savesscreen+6
#define yrm savesscreen+7
#define xrm savesscreen+8
#define grnd savesscreen+9
#define spg savesscreen+10
#define five savesscreen+11
#define four savesscreen+12
#define three savesscreen+13
#define tall savesscreen+14
#define tahl savesscreen+15
#define tll savesscreen+16
#define lapp savesscreen+17
#define arrw savesscreen+18
#define timo savesscreen+19
#define timtw savesscreen+20
#define picd savesscreen+21
#define chr savesscreen+22
#define score savesscreen+29
#define carp savesscreen+24 
#define carpp savesscreen+25 
#define catp savesscreen+26 
#define stno savesscreen+32
#define spcar savesscreen+33
#define course savesscreen+35
#define chr2 savesscreen+36
#define nitro savesscreen+37
#define ncount savesscreen+38 
#define mspd savesscreen+39
#define nison savesscreen+40
#define money savesscreen+41
#define scotr savesscreen+43
#define scott savesscreen+45
#define lives savesscreen+47
#define temp savesscreen+48
#define tp2 savesscreen+50

 .org $9d93        ;Origin
 .db $BB,$6D             ;Compiled AsmPrgm token
  ret                  ;Header Byte 1 -- So TIOS wont run
 .db 1                  ;Header Byte 2 -- Identifies as MirageOS prog

button:                       ;Button - should be a 15x16 graphic
 .db %10101010,%10100101
 .db %01010101,%01000000
 .db %10101000,%00100110
 .db %01010110,%10000000
 .db %10100110,%00010100
 .db %01010000,%01100000
 .db %10100111,%01101100
 .db %01011110,%00001101
 .db %11111111,%11101010
 .db %11110000,%01110101
 .db %00101111,%10111110
 .db %11011111,%11010101
 .db %10000000,%00001010
 .db %10000000,%00010101
 .db %10011111,%11001010
desc:                    ;Description - zero terminated
 .db "Adv. Racer 0.99",0

progstart:
                   bcall(_grbufclr)     ; clear the buffer
  ld a,24
  ld l,a  
  ld a,40
  ld b,16               
  ld c,2        
  ld ix,intro1          
  call ilsprite 
  bcall(_grbufcpy)      
  ld a,50
  ld hl,nmm
 call centertext
  bcall(_getkey)  
  ld a,1
  ld (chr),a
  ld (stno),a
  ld a,1
  ld (course),a
   ld a,4
  ld (chr2),a
  ld hl,500
  ld (money),hl
  ld a,40
  ld (mspd),a
  ld a,5
 ld (nitro),a
   ld hl,0
   ld (scott),hl
   ld (scotr),hl
    ld a,1
    ld (lives),a   
               
frst:
  bcall(_clrlcdfull)
  ld hl,0001h
  ld (CURROW),hl
  ld hl,0000h
  ld (CURCOL),hl
  ld hl,vertext
  bcall(_puts)
 ld a,40 
 ld (PENCOL),a
 ld a,30
 ld (penrow),a 
 ld hl,stad
 bcall(_vputs)
 ld a,40 
 ld (PENCOL),a
 ld a,40
 ld (penrow),a 
 ld hl,quid
 bcall(_vputs)
 ld a,40 
 ld (PENCOL),a
 ld a,50
 ld (penrow),a 
 ld hl,keyys
 bcall(_vputs)
 ld a,(chr)
 cp 1
 call  z,upar
 cp 2
  call z,downar
  cp 3
  call z,leftar 
 bcall(_getkey)

frsts:
 cp kup
 call z,chruar        
 cp kdown
 call z,chrdar
 cp kEnter
  jp z,secnds 
  jr frst

chruar:
  ld a,(chr)
    cp 2
 call  z,upar   
    cp 3
 call  z,downar
   ret

chrdar:
   ld a,(chr)
     cp 2
   call  z,leftar
      cp 1
   call  z,downar
  ret

upar:
 ld hl, 0404h
 ld a,5
 ld (currow),hl
 bcall(_putc)         
  ld a,1
  ld (chr),a
  ret

downar:
 ld hl, 0405h
 ld a,5
 ld (currow),hl
 bcall(_putc)          
  ld a,2
  ld (chr),a
  ret

leftar:
   ld hl, 0406h
 ld a,5
 ld (currow),hl
 bcall(_putc)          ; Put the small arrow
  ld a,3
  ld (chr),a
  ret

secnds:
  ld a,(chr)
  cp 1
  jp z,chooseshop
  cp 2
   jp z,quit
  cp 3
   jp z,keydisy
 
keydisy:
   bcall(_clrlcdfull)  
  ld hl,0000h   
   ld (currow),hl
    ld hl,commd
   bcall(_puts)
   bcall(_getkey)
    jp frsts  

rrup:
   ld a,(chr2)
   cp 4
    jp z,shop
    dec a
    ld (chr2),a
    jp shop

rrdown:
    ld a,(chr2)
    cp 7
    jp z,shop
    inc a
    ld (chr2),a  
  jp shop
   

cotext:
     bcall(_clrlcdfull)  
  ld hl,0000h   
   ld (currow),hl
    ld hl,hlptxt
   bcall(_puts)
   bcall(_getkey)

chooseshop:                    
  bcall(_clrlcdfull)    ;clear screen
  ld hl,speedstr        
  ld a,1
  ld (pencol),a         
  ld (penrow),a
  bcall(_vputs)         ;Displays "CHOOSE SPEED"
  ld a,25
  ld (pencol),a
  ld a,15
  ld (penrow),a   
  ld hl,slowstr          ;Displays "2nd- Slow"
  bcall(_vputs)
  ld a,25
  ld (pencol),a
  ld a,25
  ld (penrow),a   
  ld hl,medstr
  bcall(_vputs)         ;Displays "MOde- Fast"

lilloop:
  bcall(_getcsc)        ;Keyloop to see if mode or 2nd is pressed
  cp sk2nd
  jp z,slowset
  cp skMode
  jp z,medset
  jp lilloop

slowset:
  ld a,1
  ld (tp2),a
  jp shop

medset:
  ld a,2
  ld (tp2),a
  jp timetrial

timetrial:
  bcall(_clrlcdfull)    ;clear screen
 ld hl,0000h   
  ld (currow),hl
   ld hl,speedstr2
  bcall(_puts) 
  ld hl,1500
  ld (money),hl  

lilloop2:
  bcall(_getcsc)        ;Keyloop to see if mode or 2nd is pressed
  cp sk1
  jp z,ldcourse1
  cp sk2
  jp z,ldcourse2
  cp sk3
  jp z,ldcourse3
  cp sk4
  jp z,ldcourse4
  cp sk5
  jp z,ldcourse5
  cp sk6
  jp z,ldcourse6
  cp sk7
  jp z,ldcourse7
  cp sk8
  jp z,ldcourse8
  jp lilloop2

ldcourse1:
  ld a,1
  ld (course),a
  jp shop


ldcourse2:
  ld a,2
  ld (course),a
  jp shop
 
ldcourse3:
  ld a,3
  ld (course),a
  jp shop

ldcourse4:
  ld a,4
  ld (course),a
  jp shop

ldcourse5:
  ld a,5
  ld (course),a
  jp shop

ldcourse6:
  ld a,6
  ld (course),a
  jp shop

ldcourse7:
  ld a,7
  ld (course),a
  jp shop

ldcourse8:
  ld a,8
  ld (course),a
  jp shop

   
cotext1:
   bcall(_clrlcdfull)  
  ld hl,0000h   
   ld (currow),hl
   ld a,(course)
   cp 1
   jp z,moscowt
   cp 2
   jp z,beijingt
   cp 3
    jp z,tokyot
   cp 4 
    jp z,sydneyt
    cp 5
     jp z,cairot
    cp 6
    jp z,londont
    cp 7
    jp z,parist
    cp 8
    jp z,newyorkt

disphlloop:
   ld a,80
   ld (pencol),a
   ld a,52
   ld (penrow),a            ;
   bcall(_setxxxxop2)              ; write high score
   bcall(_op2toop1)                ;
   ld      a,5                     ;
   bcall(_dispop1a) 
   ret
  
moscowt:
    ld hl,mostext
   bcall(_puts)
   ld hl,(mocrec)
   call disphlloop
   bcall(_getkey)
   jp initvars
     
beijingt:
   ld hl,beitext
  bcall(_puts)
   ld hl,(beirec)
   call disphlloop
  bcall(_getkey)
 jp initvars
        
tokyot:
  ld hl,toktext
  bcall(_puts)
  ld hl,(tokrec)
  call disphlloop
  bcall(_getkey)
  jp initvars

sydneyt:
    ld hl,sydtext
   bcall(_puts)
  ld hl,(sydrec)
   call disphlloop
   bcall(_getkey)
   jp initvars
   
cairot:
    ld hl,(caitext)
   bcall(_puts)
   ld hl,(cairec)               ;
   call disphlloop
   bcall(_getkey)
   jp initvars

londont:
    ld hl,(lontext)
   bcall(_puts)
    ld hl,lonrec
  call disphlloop
   bcall(_getkey)
   jp initvars

parist:
    ld hl,partext
   bcall(_puts)
    ld hl,(parrec)
   call disphlloop
  bcall(_getkey)
   jp initvars

newyorkt:
    ld hl,nytext
   bcall(_puts)
    ld hl,(nyrec)
  call disphlloop
   bcall(_getkey)
     jp initvars

icourse:
   ld a,(course)
   inc a
   ld (course),a
   jp cotext1


dcourse:
   ld a,(course)
   dec a
   ld (course),a
   jp cotext1       
   
shop:
  bcall(_clrlcdfull)
  ld hl,0004h
  ld (CURROW),hl
  ld hl,0000h
  ld (CURCOL),hl
  ld hl,shoptext
   bcall(_puts)
   ld hl,0000h
  ld (CURROW),hl
  ld hl,0000h
  ld (CURCOL),hl
  ld hl,moneytext
  bcall(_puts)
   ld hl,0001h
    ld (CURROW),hl
  ld hl,0000h
  ld (CURCOL),hl
  ld hl,quickr
  bcall(_puts)
   ld hl,0002h
    ld (CURROW),hl
  ld hl,0000h
  ld (CURCOL),hl
  ld hl,challr
  bcall(_puts)
   ld a,(lives)
   bcall(_setxxop1) 
  ld a,70
  ld (pencol),a
  ld a,18
  ld (penrow),a
  ld a,2 
  bcall(_dispop1a)
    ld a,(nitro)
   bcall(_setxxop1) 
  ld a,70
  ld (pencol),a
  ld a,9
  ld (penrow),a
  ld a,2 
  bcall(_dispop1a)
  ld  hl,(money)               ;
   bcall(_setxxxxop2)              ; write money
   bcall(_op2toop1)                ;
  ld a,70
   ld (pencol),a                       ;
  ld  a,0
  ld (penrow),a   
   ld      a,5                     ;
   bcall(_dispop1a) 
        ld a,1
  ld (curcol),a 
 ld a,(chr2)
 ld (currow),a
 ld a,5 
  bcall(_putc)
  bcall(_getkey)
 cp kup
 jp z,rrup
  cp kdown
  jp z,rrdown
  cp kenter
   jp z,checkitem
   jp shop

checkitem:
   ld a,(chr2)
   cp 5
    jp z,dboost
    cp 6
     jp z,mspdinc   
    cp 7
    jp z,carrpr
    cp 4
    jp z,cotext1
    jp nz,shop

dboost:
   ld de,50
   ld hl,(money)
   sbc hl,de
   ld a,h
   jp m,shop   
   ld (money),hl
   ld a,(nitro)
   inc a
   ld (nitro),a
   ld hl,(scott)
   ld de,50
   add hl,de
   ld (scott),hl   
   jp shop
   
mspdinc:
   ld de,200
   ld hl,(money)
   sbc hl,de
   ld a,h
   jp m,shop   
   ld (money),hl
   ld a,(mspd)
   inc a
   inc a
   inc a
   inc a
   inc a
   ld (mspd),a
   ld hl,(scott)
   ld de,200
   add hl,de
   ld (scott),hl
   jp shop
   
carrpr:
    ld de,250
   ld hl,(money)
   sbc hl,de
   ld a,h
   jp m,shop   
   ld (money),hl
   ld a,(lives)
   inc a
   ld (lives),a
   ld hl,(scott)
   ld de,300
   add hl,de
   ld (scott),hl
   jp shop
                                                       
initvars:
 ld a,0
 ld (nison),a
 ld a,1
 ld (grnd),a
 ld (lapp),a 
 ld a,0
 ld (five),a
 ld (four), a
 ld (three), a
 ld (xrm),a 
 ld (tall),a
 ld (tll),a
 ld (yrm),a  
 ld (arrw),a
 ld (timo),a
 ld (timtw),a
   ld (carp),a
  ld (catp),a 
 ld a,20
 ld (ncount),a
 ld (picd),a
 ld a,48
   ld (xmm),a
  ld a,2
  ld (spd),a
  ld a,40
  ld (spcar),a 
  ld hl,0
  ld (score),hl
  ld a,55
  ld l,a
  ld (ymm),a 
  ld hl,sprite
  ld (prite),hl
  call draw
    
main:
              ld a,2
     ld b,a
    call delayb 

main2: 
               
    jp roads           




Keyloop:      
    ld   a,0ffh          ;Reset keyport
    out     (1),a
    ld a, 0bfh          ;Enable Key Group with the mode in it.
    out (1), a
    in a, (1)
    cp kMode
    jp z,quit          
    cp k2nd
    jp z,up
    cp %01011111
    jp z,nspeed
    jp nz, dspeed 
    ld   a,0ffh  
    out (1), a
        
keyloop1:      
    ld   a,0ffh          ;Reset keyport
    out     (1),a
    ld a, 0FEh          ;Enable Key Group with the Arrows in it.
    out (1), a
    in a, (1)
    cp %11111101            ;Check for Left.
    jp z, Left
    cp %11111011         ;Check for Right.
    jp z, Right
    cp %11111100            ;Check for Down AND Left.
    jp z,Uleft
    cp %11111010            ;Check for Down AND Right.
    jp z, Uright
    call nz,draw
    ld   a,0ffh  
    out (1), a
    jr main

nspeed:
  ld a,(nitro)
  cp 0
  jp z,keyloop1
  ld a,(nison)
  cp 1
  jp z,keyloop1
  ld a,(nitro)
  dec a
  ld (nitro),a
  ld a,30
  ld b,a
  ld a,(spd)
  add a,b
  ld (spd),a
  ld a,1
  ld (nison),a
  jp keyloop1
  
gcar:
   ld a,(spcar)       ;ghost car speed
   ld b,a
   ld a,(carp)
   add a,b
   ld (carp),a
   sub 100
   ld (carpp),a 
   jp p,gpos
   jp m,gdrow  
     

gpos:
  ld a,(carpp)  
  ld (carp),a    
  ld a,(catp)
   inc a
  ld (catp),a  
  jp  gdrow

gdrow:
  ld a,(tll)
   ld b,a
  ld a,(catp)
  sub b
  cp 4
  jp z,dcar5
  cp 3
  jp z,dcar4
  cp 2
  jp z,dcar3
  cp 1
  jp z,dcar2
   cp 0
   jp z,dcar1 
  ret 

dcar5:
 ld a,36 
 ld l,a  
 ld a,46
 ld b,8             
 ld c,1     
 ld ix,gar5               
 call ilsprite  
 bcall(_grbufcpy)           
 ret 

dcar4:
  ld a,40
  ld l,a  
 ld a,46
 ld b,8             
 ld c,1     
 ld ix,gar4              
 call ilsprite  
 bcall(_grbufcpy)           
 ret

dcar3:
  ld a,47
  ld l,a  
 ld a,44
 ld b,8             
 ld c,2     
 ld ix,gar3              
 call ilsprite  
 bcall(_grbufcpy)           
 ret 

dcar2:
  ld a,52
  ld l,a  
 ld a,44
 ld b,8             
 ld c,2     
 ld ix,gar2              
 call ilsprite  
 bcall(_grbufcpy)           
 ret

dcar1:
  ld a,60
  ld l,a  
 ld a,44
 ld b,8             
 ld c,2     
 ld ix,gar1              
 call ilsprite  
 bcall(_grbufcpy)           
 ret

   
 
tally:
     ld a,(spd)
     ld b,a 
     ld a,(tall)
     add a,b
    ld (tall),a 
     sub 100
     ld (tahl),a
      jp m,keyloop
      jp p,tahly
        ret

tahly
   ld a,(tahl)
   ld (tall),a
   ld a,(tll) 
   inc a
   ld (tll),a

tracknm:
   ld a,(course)
   cp 1
   jp z,moscow
   cp 2
   jp z,beijing
   cp 3
    jp z,tokyo
   cp 4 
    jp z,sydney
   cp 5
    jp z,cairo
    cp 6
    jp z,london
    cp 7
    jp z,paris
    cp 8
     jp z,newyork
    

moscow:
   ld a,(tll)
   cp 20
  jp z,arrwr
  cp 21
  jp z,fturr
  cp 25
  jp z,pmove
  cp 28
  jp z,fsrt
  cp 50
  jp z,arrnr
  cp 51
   jp z,fturn 
  cp 55
   jp z,pmove
   cp 59
  jp z,fsrt
  cp 64
  jp z, newlap 
     jp nz,keyloop
    ret 

beijing:
  ld a,(tll)
  cp 20
  jp z,arrwr
  cp 21
  jp z,fturr
  cp 26
  jp z,pmove
  cp 29
  jp z,arrwr  
  cp 30
  jp z,fturn
  cp 31
  jp z,fsrt
  cp 49
  jp z,arrnr
  cp 50
  jp z,fturn
  cp 57
  jp z,nmove
  cp 59
  jp z,arrqu
  cp 63
  jp z,fsrt
  cp 65
  jp z,arrqu
  cp 66
  jp z,fturr
  cp 68
  jp z,fturn
  cp 69
  jp z,arrwl
  cp 70
  jp z,fsrt
  cp 73
  jp z,newlap
  jp nz,keyloop
  ret  

tokyo:
   ld a,(tll)
   cp 15
   jp z,arrwl
   cp 16
   jp z,fturn
   cp 20
   jp z,fsrt
   cp 23
   jp z,arrqu
   cp 24
   jp z,fturr
   cp 26
   jp z,fturn
   cp 36
   jp z,fsrt
   cp 38
   jp z,arrwl
   cp 39 
   jp z,fturr
   cp 45
   jp z,fsrt
   cp 47
   jp z,arrwl
   cp 48
   jp z,fturn
   cp 55
   jp z,fsrt
   cp 60
   jp z,newlap
   jp nz,keyloop
   ret

sydney:
  ld a,(tll)
  cp 4
  jp z,arrwr
  cp 5
  jp z,arrqu
  cp 6
  jp z,fturr
  cp 16
  jp z,fsrt
  cp 25
  jp z,arrwl
  cp 26
  jp z,fturn
  cp 35
  jp z,fsrt
  cp 45
  jp z,arrnr
  cp 46
  jp z,fturn
  cp 50
  jp z,fsrt
  cp 55
  jp z,newlap
  jp nz,keyloop
  ret

london:
  ld a,(tll)
  cp 15
  jp z,arrwl
  cp 16
  jp z,fturn
  cp 20
  jp z,fsrt
  cp 30
  jp z,arrwl
  cp 32
  jp z,fturn
  cp 40
  jp z,arrwr
  cp 41
  jp z,fturr
  cp 43
  jp z,fturn
  cp 44
  jp z,arrwl
  cp 60
  jp z,arrwr
  cp 61
  jp z,fturr
  cp 63
  jp z,fsrt
  cp 68
  jp z,newlap
  jp nz,keyloop  
  ret

cairo:
  ld a,(tll)
  cp 20
  jp z,arrqu
  cp 21
  jp z,fturn
  cp 22
  jp z,arrnr
  cp 25
  jp z,fsrt
  cp 35
  jp z,arrwl
  cp 36
  jp z,fturr
  cp 43
  jp z,fsrt
  cp 50
  jp z,arrwr
  cp 51
  jp z,fturr
  cp 59
  jp z,fsrt
  cp 70
  jp z,arrwr
  cp 71
  jp z,fturr
  cp 76
  jp z,fsrt
  cp 80
  jp z,newlap
  jp nz,keyloop

paris:
  ld a,(tll)
  cp 5
  jp z,arrwl
  cp 7
  jp z,fturn
  cp 10
  jp z,fsrt
  cp 30
  jp z,arrnl
  cp 31
  jp z,fturr
  cp 35
  jp z,fturn
  cp 36
  jp z,arrwl
  cp 38 
  jp z,arrwr
  cp 40
  jp z,fsrt
  cp 50
  jp z,arrnr
  cp 51
  jp z,fturr
  cp 52
  jp z,fturn
  cp 56
  jp z,arrqu
  cp 57
  jp z,fturr
  cp 59
  jp z,fturn
  cp 61
  jp z,fsrt
  cp 70
  jp z,newlap
  jp nz,keyloop

newyork:
   ld a,(tll)
   cp 14
   jp z,arrwl
   cp 16
   jp z,fturn
   cp 20
   jp z,fsrt
   cp 23
   jp z,arrqu
   cp 24
   jp z,fturr
   cp 26
   jp z,fturn
   cp 36
   jp z,fsrt
   cp 50
  jp z,arrwl
  cp 51
   jp z,fturr 
  cp 52
  jp z,arrwr
    cp 55
   jp z,pmove
   cp 56
   jp z,fsrt
   cp 61
   jp z,arrwl
   cp 62
   jp z,fturr
   cp 64
   jp z,arrwr    
   cp 70
  jp z,fsrt
  cp 90
  jp z, newlap 
     jp nz,keyloop
    ret 

nmove:
  ld a,(picd)
  inc a
  inc a
  inc a
  ld (picd),a
  jp keyloop
 
pmove:
  ld a,(picd)
  dec a
 dec a
  dec a
  ld (picd),a
   jp keyloop

arrwl:
  ld a,1
  ld (arrw),a
  jp keyloop

arrnl:
  ld a,3
  ld (arrw),a
  jp keyloop
  
arrnr:
 ld a,4
  ld (arrw),a
  jp keyloop
 
arrqu:
  ld a,5
  ld (arrw),a
  jp keyloop
  
arrwr:
  ld a,2
  ld (arrw),a
  jp keyloop
  
newlap:
       ld a,51
    ld (spcar),a
     ld a,1
     ld (tll),a
    ld a,(lapp)
    inc a
    ld (lapp),a
    cp 3
    jp z,qtime
    jp nz,keyloop   
    ret 

fsrt:
   ld a,0
   ld (yrm),a
   ld (arrw),a
   jp keyloop 
   ret

fturn:
   ld a,1
   ld (yrm),a
   jp keyloop
   ret

fturr:
  ld a,2
  ld (yrm),a
  jp keyloop
  ret

roads:
   ld a,(spg)
   sub 3
   jp m,one
   sub 10
  jp m,fiv
   sub 10
   jp m,fou
   sub 10 
    jp m,thre
   sub 10
    jp m,two
    jp two

fiv:
  ld a,1
  ld (grnd),a
  ld a,(five)
  inc a
  ld (five),a
  cp 5
  jp z, nzroad
  cp 6
  jp z,nzroad
  cp 7
  jp z,nzroad
  cp 8
  jp z,max 
  jp nz, zroad
 ret
    
fou:
 ld a,2
 ld (grnd),a
 ld a,(four)
 inc a 
 ld (four),a
 cp 4
 jp z, nzroad
  cp 5
  jp z, nzroad
  cp 6
  jp z,max
 jp nz, zroad
 ret

thre:
 ld a,3
 ld (grnd), a
 ld a,(three)
 inc a
 ld (three),a
 cp 3
 jp z, nzroad
 cp 4
 jp z,max
 jp nz, zroad
 ret

two:
 ld a,4
 ld (grnd),a
 jp rood
 ret

one:
 ld a,1
 ld (xrm),a
 jp rood
 ret

rood:
  ld a,(xrm)
  cp 1
  jp  z,zroad
  jp  nz,nzroad
  ret

max:
    ld a,0
   ld (five),a
   ld (four), a
   ld (three), a 
 jp nzroad
  ret


zroad:
  ld a,0
  ld (xrm),a
  ld a,36
  ld l,a  
  ld a,0
  ld b,24               
  ld c,12       
   call spcheck
  call ilsprite 
  bcall(_grbufcpy)
    ld hl,(score)               ;
     inc hl
     ld (score),hl    
     bcall(_setxxxxop2)              ;
        bcall(_op2toop1)                ;
        ld a,70
        ld (pencol),a                       ;
        ld  a,10
        ld (penrow),a  
        ld a,5
       bcall(_dispop1a)        
  jp tally
  ret

nzroad:
  ld a,1
  ld (xrm),a
  ld ix, road1 
  ld a,36
  ld l,a  
  ld a,0
  ld b,24               
  ld c,12       
   call aspcheck
  call ilsprite 
  bcall(_grbufcpy)
    ld hl,(score)               ;
     inc hl
     ld (score),hl    
     bcall(_setxxxxop2)              ;
        bcall(_op2toop1)                ;
        ld a,70
        ld (pencol),a                       ;
        ld  a,10
        ld (penrow),a  
        ld a,5
       bcall(_dispop1a)        
  jp tally
  ret

spcheck:
   ld a,(yrm)
   cp 1
   call z,yest
   cp 2
   call z,yestr
   cp 0
    call z,yess
    ret

aspcheck:
   ld a,(yrm)
   cp 1
   call z,ayest
    cp 2
   call z,ayestr
    cp 0    
   call z,ayess
    ret

yess:
  ld ix,road
  ret 
    
yest:
  ld ix,turn
  ret

yestr:
  ld ix,turnr
  ret 

ayess:
  ld ix,road1
  ret

ayest:
  ld ix,turn1
  ret

ayestr:
  ld ix, turnr1
  ret

Left:
 ld a,(xmm)
 dec a
 dec a
 ld (xmm), a
  call draw
 jp main 
 ret

Right:
 ld a,(xmm)
 inc a
 inc a
 ld (xmm), a
  call draw
 jp main 
 ret

Up: 
 ld a,(spd)
 ld l,a  
 inc l
 ld a,l 
 ld (spd), a
 jp keyloop1 
 ret

Down:
 ld a,(spd)
 dec a
  dec a
  ld (spd), a
 call draw
 jp main
 ret

Uleft:
  ld a,(xmm)
 dec a    
  dec a
  dec a
  ld (xmm), a
  call draw
  jp main
 ret

Uright:
 ld a,(xmm)
 inc a  
 inc a
 inc a  
  ld (xmm), a
 call draw
 jp main
 ret

chkrt:
  ld a,(xmm)
  sub 60
  jp  p,carsss
  ret

chklt:
  ld a,(xmm)
 sub 23       
  jp m,carsss
  ret

dspeed:
 call dspchk
  ld a, (spd)
  dec a 
  ld (spd), a
 ld a,(yrm)
 cp 0  
 jp z,keyloop1
 cp 1
 jp z,caradjl
 cp 2
 jp z,caradjr
 ret
 
caradjl:
 ld a,(xmm)
 dec a
 ld (xmm), a 
 jp keyloop1 
 
caradjr:
 ld a,(xmm)
 inc a
 ld (xmm),a
 jp keyloop1   
 

dspchk:
 ld a,(mspd)
 ld b,a
 ld a,(spd) 
 cp 0
 call z,sup
 cp 1
 call z,sup 
 cp b
 call z,dup
 sub b
 call p,sdup  
 ret

sup:
   ld a ,(spd)
   inc a
   ld (spd),a
   ret

dup:
 ld a ,(spd)
 dec a
 ld (spd),a
 ret     

sdup:
 ld a ,(spd)
 dec a
 dec a
 dec a
 ld (spd),a
 ret 
       
Draw:
   ld a,(spd) 
 ld (spg),a 
 dec a
 bcall(_setxxop1) 
 ld hl,0000h
 ld (pencol), hl 
 ld a,2 
 bcall(_dispop1a)
  bcall(_setxxop1) 
  ld a,11
  ld (PENCOL),a
  ld a,0
  ld (penrow),a 
  ld hl,mphd
  bcall(_vputs)
 bcall(_grbufclr)
 call stage
 call spadj
 call chklt
 call chkrt
 call charrw
   call dspchk
 call isnon
   ld a,(ymm)
  ld l,a  
  ld a,(xmm)
  ld b,8             
  ld c,2     
  ld ix,sprite               
  call ilsprite  
    call lapput
    bcall(_grbufcpy)           
     call gcar
     ret 

isnon:
  ld a,(nison)
  cp 0
  ret z
  ld a,(ncount)
  dec a
  ld (ncount),a
  cp 0
  ret nz
  ld a,0
  ld (nison),a
  ld a,20
  ld (ncount),a
  ret
  
lapput:
  ld a,(lapp)
  cp 1
  call z,lapp1 
  call nz,lapp2
  ret 

lapp1:
  ld a,0
  ld l,a  
  ld a,70
  ld b,8             
  ld c,2  
  ld ix,lap_1
  call ilsprite
  ret

lapp2:
  ld a,0
  ld l,a  
  ld a,70
  ld b,8             
  ld c,2  
  ld ix,lap_2
  call ilsprite
  ret  

adzero:
  ld a,0
  bcall(_setxxop1)
  ld a,85
  ld (pencol), a 
  ld a,10
  ld (penrow),a 
  ld a,2 
  bcall(_dispop1a)
  ld a, 89
  ld (pencol),a
  ret 
  
charrw:
  ld a,(arrw)
  cp 0
   ret z
   cp 1
   call  z,drleft
   cp 2
   call  z,drright
   cp 3
   call z,drnright
   cp 4
   call z,drnleft
   cp 5
   call z,drqu
   ret


drnright:
  ld b,8
  ld a,25
  ld l,a
  ld a,70
  ld ix,arnleft
  call isprite
  ret
  
drnleft:
 ld b,8
  ld a,25
  ld l,a
  ld a,70
  ld ix,arnright
  call isprite
  ret
  
drqu:
  ld b,8
  ld a,25
  ld l,a
  ld a,70
  ld ix,arqu
  call isprite
  ret
  
drleft:
  ld b,8
  ld a,25
  ld l,a
  ld a,70
  ld ix,arleft
  call isprite
  ret

drright:
  ld b,8
  ld a,25
  ld l,a
  ld a,70
  ld ix,arright
  call isprite
  ret  

spadj:
 ld a,(yrm)
 cp 1
 call z,adjt
 cp 2 
 call z,adjtr
 cp 0
 ret z
 ret

adjt:
  ld a,(xmm) 
 sub 60
  call p,carsss
  ld a,(spd)
 sub 20
 ret m
  ld a,(xmm)
  inc a
 ld (xmm),a
  ld a,(spd)
 sub 30
 ret m      
   ld a,(xmm)
     inc a
   ld (xmm),a  
  ld a,(spd)
 sub 45
  ret m      
 ld a,(xmm)
 inc a
 ld (xmm),a
 ld a,(spd)
 sub 60
 ret m      
 ld a,(xmm)
 inc a
 ld (xmm),a
  ret

adjtr:
 ld a,(xmm) 
 sub 23
 call m,carsss
  ld a,(spd)
  sub 20
  ret m
 ld a,(xmm)
 dec a
 ld (xmm),a
 ld a,(spd)
 sub 30
  ret m      
 ld a,(xmm)
 dec a
 ld (xmm),a  
 ld a,(spd)
  sub 45
  ret m
 ld a,(xmm)
 dec a
 ld (xmm),a
 ld a,(spd)
  sub 60
  ret m
 ld a,(xmm)
 dec a
 ld (xmm),a
  ret

carsss:
 bcall(_grbufclr) 
 ld a,(ymm)
 ld l,a  
 ld a,(xmm)
 ld b,8             
 ld c,2     
 ld ix,sprite               
 call ilsprite  
 bcall(_grbufcpy)   
 bcall(_grbufclr) 
 call dlylp
 ld a,47
 ld l,a  
 ld a,(xmm)
 ld b,8             
 ld c,2     
 dec a 
 ld (xmm),a
  ld ix, car2 
 call ilsprite  
 bcall(_grbufcpy)   
 bcall(_grbufclr)
  call dlylp
   ld a,47
 ld l,a  
 ld a,(xmm)
 ld b,16                
 ld c,2     
 ld ix,car3
 call ilsprite  
 bcall(_grbufcpy)   
 bcall(_grbufclr)
  call dlylp
  ld a,47
 ld l,a  
 ld a,(xmm)
 ld b,16                
 ld c,2     
 ld ix,car4
 call ilsprite  
 bcall(_grbufcpy)   
 ld a, 40
 ld (xmm),a
 ld a,0
 ld (spd),a
 jp draw
 ret

dlylp: 
 ld a,20
  ld b,a
 call delayb   
  ret


         

Stage:
  ld h,0   
  ld l,35
  ld d,95 
  ld e,35
  call fastlineb 
    ld a,(course)
   cp 1
   jp z,moscowp
   cp 2
   jp z,beijingp
   cp 3
   jp z,tokyop
   cp 4 
    jp z,sydneyp
   cp 5
    jp z,cairop
    cp 6
    jp z,londonp
    cp 7
    jp z,parisp
    cp 8
     jp z,newyorkp 
     ret


moscowp:
  ld a,11
  ld l,a
  ld b,24
  ld c,5
  ld a,(picd)
  ld ix, moscr
  call ilsprite
  bcall(_grbufcpy)
      ret 
    ret
       
beijingp:
  ld a,11
  ld l,a
  ld b,24
  ld c,5
  ld a,(picd)
  ld ix, beijr
  call ilsprite
  bcall(_grbufcpy)
      ret  
      ret

sydneyp:
  ld a,11
  ld l,a
  ld b,24
  ld c,5
  ld a,(picd)
  ld ix, sydnr
  call ilsprite
  bcall(_grbufcpy)
      ret  
      ret
      
tokyop:
  ld a,11
  ld l,a
  ld b,24
  ld c,5
  ld a,(picd)
  ld ix, tokyr
  call ilsprite
  bcall(_grbufcpy)
      ret  
      ret

cairop:
  ld a,11
  ld l,a
  ld b,24
  ld c,5
  ld a,(picd)
  ld ix, cairr
  call ilsprite
  bcall(_grbufcpy)
      ret  
     ret
 
londonp:
  ld a,11
  ld l,a
  ld b,24
  ld c,5
  ld a,(picd)
  ld ix, londr
  call ilsprite
  bcall(_grbufcpy)
      ret  
      ret
      
parisp:
  ld a,11
  ld l,a
  ld b,24
  ld c,5
  ld a,(picd)
  ld ix, parir
  call ilsprite
  bcall(_grbufcpy)
      ret  
     ret 

newyorkp:
  ld a,11
  ld l,a
  ld b,24
  ld c,5
  ld a,(picd)
  ld ix, nyr
  call ilsprite
  bcall(_grbufcpy)
   ret  
     ret
      
qtime:
   bcall(_clrLCDfull)                  ;
  bcall(_homeup)                  ;
  ld      hl,timestr             ;
  bcall(_puts)                    ; write "Score: "
   ld      hl,(score)               ;
   bcall(_setxxxxop2)              ; write high score
   bcall(_op2toop1)                ;
  ld a,60
   ld (pencol),a                       ;
  ld  a,0
  ld (penrow),a   
   ld      a,5                     ;
   bcall(_dispop1a)                ;;
   ld a,(course)
   cp 1
   jp z,moscowe
   cp 2
   jp z,beijinge
   cp 3
   jp z,tokyoe
   cp 4 
   jp z,sydneye
   cp 5
   jp z,cairoe
   cp 6
   jp z,londone
   cp 7
   jp z,parise
   cp 8
   jp z,newyorke 

moscowe:
   ld hl,(mocrec)
   ld de,(score)
   sbc hl,de
   ld a,h
   call p,mocnrec
   bcall(_getkey)
   ld a,(tp2)
   cp 2
   jp z,progstart


   ld hl,330
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,fail
   ld hl,290
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,normal
   jp super

mocnrec:
  ld hl,0002h
  ld (CURROW),hl
  ld hl,0000h
  ld (CURCOL),hl
  ld hl,newrecstr
  ld de,(score)
  ld (mocrec),de
  bcall(_puts)
  ret 

   
beijinge:
   ld hl,(beirec)
   ld de,(score)
   sbc hl,de
   ld a,h
   call p,beinrec
  bcall(_getkey)
   ld a,(tp2)
   cp 2
   jp z,progstart


    ld hl,340
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,fail
   ld hl,310
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,normal
   jp super
   
beinrec:
  ld hl,0002h
  ld (CURROW),hl
  ld hl,0000h
  ld (CURCOL),hl
  ld hl,newrecstr
  ld de,(score)
  ld (beirec),de
  bcall(_puts)
  ret 

tokyoe:
   ld hl,(tokrec)
   ld de,(score)
   sbc hl,de
   ld a,h
   call p,toknrec
  bcall(_getkey)
   ld a,(tp2)
   cp 2
   jp z,progstart

    ld hl,325
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,fail 
   ld hl,280
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,normal
   jp super

toknrec:
  ld hl,0002h
  ld (CURROW),hl
  ld hl,0000h
  ld (CURCOL),hl
  ld hl,newrecstr
  ld de,(score)
  ld (tokrec),de
  bcall(_puts)
  ret 

sydneye:
   ld hl,(sydrec)
   ld de,(score)
   sbc hl,de
   ld a,h
   call p,sydnrec
  bcall(_getkey)
   ld a,(tp2)
   cp 2
   jp z,progstart

     ld hl,275
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,fail 
   ld hl,220
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,normal
   jp super

sydnrec:
  ld hl,0002h
  ld (CURROW),hl
  ld hl,0000h
  ld (CURCOL),hl
  ld hl,newrecstr
  ld de,(score)
  ld (sydrec),de
  bcall(_puts)
  ret  
   
cairoe:
   ld hl,(cairec)
   ld de,(score)
   sbc hl,de
   ld a,h
   call p,cainrec
  bcall(_getkey)
   ld a,(tp2)
   cp 2
   jp z,progstart
 
    ld hl,360
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,fail 
   ld hl,340
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,normal
   jp super
   
cainrec:
  ld hl,0002h
  ld (CURROW),hl
  ld hl,0000h
  ld (CURCOL),hl
  ld hl,newrecstr
  ld de,(score)
  ld (cairec),de
  bcall(_puts)
  ret  

londone:
   ld hl,(lonrec)
   ld de,(score)
   sbc hl,de
   ld a,h
   call p,lonnrec
  bcall(_getkey)
   ld a,(tp2)
   cp 2
   jp z,progstart

    ld hl,330
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,fail 
   ld hl,295
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,normal
   jp super
   
lonnrec:
  ld hl,0002h
  ld (CURROW),hl
  ld hl,0000h
  ld (CURCOL),hl
  ld hl,newrecstr
  ld de,(score)
  ld (lonrec),de
  bcall(_puts)
  ret  

parise:
   ld hl,(parrec)
   ld de,(score)
   sbc hl,de
   ld a,h
   call p,parnrec
  bcall(_getkey)
   ld a,(tp2)
   cp 2
   jp z,progstart

    ld hl,350
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,fail 
   ld hl,310
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,normal
   jp super

parnrec:
  ld hl,0002h
  ld (CURROW),hl
  ld hl,0000h
  ld (CURCOL),hl
  ld hl,newrecstr
  ld de,(score)
  ld (parrec),de
  bcall(_puts)
  ret  

   
newyorke:
   ld hl,(nyrec)
   ld de,(score)
   sbc hl,de
   ld a,h
   call p,nynrec
  bcall(_getkey)
   ld a,(tp2)
   cp 2
   jp z,progstart

    ld hl,350
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,fail 
   ld hl,335
   ld de,(score)
   sbc hl,de
   ld a,h
   jp m,normal
   jp super

nynrec:
  ld hl,0002h
  ld (CURROW),hl
  ld hl,0000h
  ld (CURCOL),hl
  ld hl,newrecstr
  ld de,(score)
  ld (nyrec),de
  bcall(_puts)
  ret 

fail:
  bcall(_clrlcdfull)
  ld hl,failstr
  ld a,1
  ld (pencol),a         
  ld (penrow),a
  bcall(_vputs)         ;Displays "CHOOSE SPEED"
  bcall(_getkey)
  ld a,(lives)
  dec a
  ld (lives),a
  cp 0 
  jp z,youvefailed
  jp nz,shop
  
super:
   ld hl,0002h
  ld (CURROW),hl
  ld hl,0000h
  ld (CURCOL),hl
  ld hl,challe
  bcall(_puts) 
  ld hl,(money)
  ld de,300
  add hl,de
  ld (money),hl 
  ld hl,(scott)
  ld de,250
  add hl,de
  ld (scott),hl 
  bcall(_getkey) 
  jp shoptally
  
normal:
    ld hl,0002h
  ld (CURROW),hl
  ld hl,0000h
  ld (CURCOL),hl
  ld hl,norme
  bcall(_puts) 
  ld hl,(money)
  ld de,150
  add hl,de
  ld (money),hl 
  bcall(_getkey) 
  jp shoptally 

youvefailed:
  bcall(_clrlcdfull)
  ld hl,deadstr
  ld a,1
  ld (pencol),a         
  ld (penrow),a
  bcall(_vputs)         ;Displays "CHOOSE SPEED"
  bcall(_getkey)
  jp gameover


gameover:
  bcall(_clrlcdfull)
  bcall(_grbufclr)
  ld a,20
  ld l,a
  ld b,24
  ld c,5
  ld a,30
  ld ix, gover
  call ilsprite
  bcall(_grbufcpy)
  ld hl,(scott)
  ld de,(money)
  add hl,de
  ld (scott),hl
  bcall(_getkey)
  jp now2

shoptally:    
  ld de,(score)
  ld hl,1000
  sbc hl,de
  ld (scotr),hl
  ld de,(scotr)
  ld hl,(scott)
  add hl,de
  ld (scott),hl
  ld a,(course)
  inc a
  ld (course),a
  cp 9
  jp z,itsfinished
  jp shop
 
itsfinished:
  bcall(_clrlcdfull)
  ld hl,congratstr
  ld a,1
  ld (pencol),a         
  ld (penrow),a
  bcall(_vputs)         ;Displays "CHOOSE SPEED"
  bcall(_getkey)
  jp gameover

exitl:
  bcall(_getkey)
  cp kEnter
  jp z, shop
   jr exitl
 
Quit:
 bcall(_clrlcdfull) 
 bcall(_grbufclr)
 ret
 
do_scores:
         ld       hl,(lowest)      ;See if ya got a hi-score
         ld       de,(scott)
         bcall(_CPHLDE)
         ret      nc
         bcall(_clrlcdfull)
         ld       de,0
         ld       hl,hi_score_str
         call     DTX
         ld       hl,lowest+2
         ld       (temp),hl
         ld       b,11
space_loop:
         ld       (hl),32
         inc      hl
         djnz     space_loop
         ld       ix,(temp)
         ld       b,0
enter_name_loop:
       push bc
         bcall(_getcsc)
       pop bc
         or       a
         jr       z,enter_name_loop
         cp       $38
         jr       z,backup
         cp       $09
         jr       z,nomore
         ld       c,a
         ld       a,10
         cp       b
         jr       z,enter_name_loop
         ld       hl,chartable-10
         ld       e,c
         ld       d,0
         add      hl,de
         ld       a,(hl)
         ld       (ix),a
         bcall(_putc) 
         inc      b
         inc      ix
         jr       enter_name_loop
backup:  dec      b
         ld       a,255
         cp       b
         jr       z,too_far
         dec      ix
         ld       (ix),32
         ld       hl,CURCOL
         dec      (hl)
         ld       a,32
         bcall(_putc)
         dec      (hl)
         jr       enter_name_loop
too_far: inc      b
         jr       enter_name_loop
nomore:
         ld       hl,lowest
         ld       de,(scott)
         ld       (hl),e
         push     hl
         inc      hl
         ld       (hl),d
         pop      ix              ; hiscore table
         ld       b,6
sort_scores:
         ld       e,(ix)
         ld       d,(ix+1)
         ld       l,(ix-14)
         ld       h,(ix-13)
         bcall(_CPHLDE)
         ret      nc
         push     bc
         ld       b,14
         ld       d,0
exg_loop:
         ld       e,(ix)
         ld       c,(ix-14)
         ld       (ix),c
         ld       (ix-14),e
         inc      ix
         inc      hl
         djnz     exg_loop
         ld       de,-28
         add      ix,de
         pop      bc
         djnz     sort_scores
       ret
       
DTX:
         ld       (CURROW),de
       bcall(_puts)
         ret
DMX:
         ld       (PENCOL),de
         bcall(_vputs)
         ret

now2:
         call     do_scores
         bcall(_clrlcdfull)
         ld       de,0
         ld       hl,hstitle
         call     DTX
         ld       de,hsdata
         ld       b,7                                        
high_display_loop:                         ;Display high scores
    ld       a,(de)
    ld       l,a
    inc      de
    ld       a,(de)
    ld       h,a
    inc      de
    push     de
    bcall(_disphl)
      ld hl,CURCOL
      ld (hl),0
    pop      hl
    bcall(_puts)
    ex       de,hl
      ld hl,CURROW
      inc (hl)
      ld a,11
      ld (CURCOL),a
    djnz     high_display_loop

loopwait: 
     bcall(_getkey)
     cp kEnter
     jp z,progstart
     jr loopwait

congratstr: .db "Congrats, you" 
            .db "finished the "
            .db "challenge mode",0
failstr: .db "you failed to qualify",0
deadstr: .db "you are out of lives",0
vertext:  .db " Adv. Racer 0.99 ",0
timestr:    .db "time",0  
highstr:  .db "new record", 0
nmm:    .db     "Nick Monu ",0
prs:    .db     "Presents...",0
lapn:     .db  "lap",0
mphd:      .db "mph",0
stad:    .db "start",0 
quid:    .db "quit",0
keyys:  .db "controls",0
quickr:   .db "DEL boosts",0
challr:    .db "Lives",0
challe:  .db "Challenge time  "
           .db "- - achieved - -"
           .db "Money + 300     "
           .db "Score + 250     ",0

norme:   .db "Qualifying time "
           .db "- - achieved - -"
           .db "Money + 150     ",0
           
newrecstr:   .db "New Record!!!",0

hlptxt: .db "use left / right"
            .db "to navigate     "
           .db  "                "
            .db "press enter",0 

ftime:   .dw  320
ftimemos:   .dw 309

hi_score_str:
         .db      " --You got a--  "
         .db      " --high score-- "
         .db      "Enter your name:",0
         
hstitle: .db      "== HIGHSCORES ==",0
hsdata:  
         .dw      7500
         .db      "Nick Monu  ",0
         .dw     7000
         .db      "Nick Monu  ",0
         .dw      6500
         .db      "Nick Monu  ",0
         .dw     6000
         .db      "Nick Monu  ",0
         .dw      5750
         .db      "Nick Monu  ",0
         .dw      5250
         .db      "Nick Monu  ",0
lowest   .dw      5000
         .db      "Nick Monu  ",0

chartable:
         .db      ":WRMH."
         .DB      "..0VQLG!..ZUPKFC"
         .DB      "..YTOJEBX.>SNIDA"
         .DB      ".12345.."
         
commd:   .db  "2ND- forward    "
                 .db  "LEFT- turn left "
                 .db  "RIGHT- t right  "
                 .db  "MODE- quit race "
                 .db  "DEL- super boost" 
                 .db  "DOWN+ Left/Right"
                 .db  "  slide turn    ",0
                  
moneytext:   .db "money",0
shoptext:    .db "   -SHOP- (race)"
            .db "   DEL boost(50)"
            .db "   Speed+5 (200)"
            .db "   Life+1  (250)",0 

mostext:   .db "MOSCOW       1/8"
                  .db "Speed-way       "
                  .db  "                "
                  .db  "Times:          "
                  .db  "Qualify:     330"  
                  .db  "Challenge:   290"
                  .db  "Record:",0

beitext:   .db "BEIJING      2/8"
                  .db "Two turns       "
                  .db  "                "
                  .db  "Times:          "
                  .db  "Qualify:     340"  
                  .db  "Challenge:   310"
                  .db  "Record:",0

toktext:     .db "TOKYO        3/8"
           .db "Errors in       "
           .db  "construction    "
          .db  "Times:          "
          .db  "Qualify:     370"  
         .db  "Challenge:   320"
        .db  "Record:",0

sydtext:    .db "SYDNEY       4/8"
                  .db "Three turns     "
                  .db  "                "
                  .db  "Times:          "
                  .db  "Qualify:     300"  
                  .db  "Challenge:   250"
                  .db  "Record:",0

caitext:       .db "CAIRO        5/8"
                  .db "Four turns      "
                  .db  "                "
                  .db  "Times:          "
                  .db  "Qualify:     360"  
                  .db  "Challenge:   340"
              .db  "Record:",0

lontext:     .db "LONDON       6/8"
                  .db "Big turn        "
                  .db  "                "
                  .db  "Times:          "
                  .db  "Qualify:     330"  
                  .db  "Challenge:   295"
                  .db  "Record:",0

partext:      .db "PARIS        7/8"
                  .db "Curves          "
                  .db  "                "
                  .db  "Times:          "
                  .db  "Qualify:     335"  
                  .db  "Challenge:   310"
                  .db  "Record:",0

nytext:       .db "NEW YORK     8/8"
                  .db "Speed-way 2     "
                  .db  "                "
                  .db  "Times:          "
                  .db  "Qualify:     350"  
                  .db  "Challenge:   335"
              .db  "Record:",0

speedstr:
 .db "CHOOSE GAME",0

slowstr:
 .db "2nd - Challenge",0

medstr:
 .db "MODE - Time Trial",0

speedstr2:
 .db "1 - Moscow      "
 .db "2 - Beijing     "
 .db "3 - Tokyo       "
 .db "4 - Sydney      "
 .db "5 - Cairo       "
 .db "6 - London      "
 .db "7 - Paris       "
 .db "8 - New York    ",0

 
mocrec:
 .dw 310,0

beirec:
 .dw 320,0

tokrec:
 .dw 330,0

sydrec:
 .dw 270,0

cairec:
 .dw 350,0

lonrec:
 .dw 300,0

parrec:
 .dw 320,0

nyrec:
 .dw 340,0


 
arleft:
   .db %00000000
 .db %00100000
 .db %01100000
 .db %11111100
 .db %11111110
 .db %01100110
 .db %00100110
 .db %00000110

arright:
  .db %00000000
 .db %00000100
 .db %00000110
 .db %00111111
 .db %01111111
 .db %01100110
 .db %01100100
 .db %01100000

arnleft:
 .db %00000011
 .db %00100110
 .db %01101100
 .db %11111100
 .db %11111110
 .db %01110110
 .db %00100110
 .db %11000110

arnright:
 .db %11000000
 .db %01100100
 .db %00110110
 .db %00111111
 .db %01111111
 .db %01101110
 .db %01100110
 .db %01100011

arqu: 
 .db %00011000
 .db %00100100
 .db %00100100
 .db %00000100
 .db %00001000
 .db %00001000
 .db %00000000
 .db %00001000



intro1:
 .db %11101110,%11111111
 .db %01000100,%11111111
 .db %01100100,%11100111
 .db %01010100,%11100111
 .db %01001100,%11111111
 .db %01000100,%11111111
 .db %11101110,%11111111
 .db %00000000,%00000000
 .db %11111110,%11100011
 .db %11111110,%01000001
 .db %11111110,%01100011
 .db %11001110,%01010101
 .db %11001110,%01001001
 .db %11111110,%01000001
 .db %11111110,%11100011
 .db %11111110,%00000000

lap_1:
   .db %10101010,%10101010
 .db %11111111,%11111111
 .db %10110001,%00011011
 .db %10110101,%01011011
 .db %10110001,%00011011
 .db %10010101,%01111011
 .db %11111111,%11111111
 .db %01010101,%01010101

lap_2
   .db %10101010,%10101010
 .db %11111111,%11111111
 .db %10110001,%00010011
 .db %10110101,%01011101
 .db %10110001,%00011011
 .db %10010101,%01110001
 .db %11111111,%11111111
 .db %01010101,%01010101

Sprite:
 .db %00000000, %00000000
 .db %00001111, %10000000
 .db %00010000, %01000000
 .db %10101010, %10101000
 .db %01111111, %11110000
 .db %01111111, %11110000
 .db %01100000, %00110000
 .db %00000000, %00000000

car2:
 .db %00000000,%00000000
 .db %00000000,%00000000
 .db %00000000,%00000000
 .db %00000000,%00000000
 .db %00001000,%00010000
 .db %00000000,%00000000
 .db %00001101,%01010100
 .db %00001011,%11101000
 .db %00100111,%00001100
 .db %00000111,%01010000
 .db %01010001,%11111100
 .db %00000100,%10111100
 .db %00010101,%00010000
 .db %00000000,%01001000
 .db %00000010,%10000000
 .db %00000000,%00000000


car3:
 .db %00000000,%00000000
 .db %00000000,%00000000
 .db %00001001,%00100000
 .db %00110000,%10001000
 .db %00000100,%00110000
 .db %00010000,%00000100
 .db %01000000,%00000000
 .db %00100000,%00000000
 .db %01000000,%00000100
 .db %00000000,%00001000
 .db %01000000,%00000000
 .db %00000000,%00111010
 .db %00110000,%10000100
 .db %10000000,%00101000
 .db %00001010,%10000000
 .db %00000000,%00000000

car4:
   .db %00010010,%00100001
 .db %00100000,%10000100
 .db %00000001,%00000010
 .db %11000000,%01001000
 .db %00000100,%00000010
 .db %10010000,%00000000
 .db %00000010,%00000010
 .db %10100000,%00100010
 .db %00000100,%00000000
 .db %00000000,%00000000
 .db %10001001,%00000000
 .db %00000000,%00000010
 .db %00000000,%00011001
 .db %01100100,%00000010
 .db %01000000,%10001000
 .db %10010010,%00101010

gar1:
 .db %00000111,%11100000
 .db %00001101,%10110000
 .db %00110110,%01101000
 .db %11101111,%11110111
 .db %01111111,%11111110
 .db %01111111,%11111110
 .db %01100000,%00000110
 .db %00000000,%00000000

gar2:
 .db %00000111,%11100000
 .db %00001101,%10110000
 .db %00010110,%01101000
 .db %01111111,%11111110
 .db %00111111,%11111100
 .db %00110000,%00001100
 .db %00000000,%00000000
 .db %00000000,%00000000

gar3:
 .db %00000111,%11100000
 .db %00001010,%01010000
 .db %00111111,%11111100
 .db %00011111,%11111000
 .db %00011000,%00011000
 .db %00000000,%00000000
 .db %00000000,%00000000
 .db %00000000,%00000000

gar4:
 .db %00111100
 .db %11111111
 .db %01111110
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000

gar5:
 .db %00000000
 .db %00001110
 .db %00011111
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000

road
 .db %11111111,%11111111,%11111111,%11111111,%01000000,%00000000,%10000000,%00000001,%01111111,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11111111,%01000000,%00000000,%00000000,%00000001,%01111111,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11111110,%10000000,%00000000,%00000000,%00000000,%10111111,%11111111,%11111111,%11111111
 .db %00000000,%00000000,%00000000,%00000000,%10000000,%00000000,%00000000,%00000000,%10000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%10000000,%00000000,%10000000,%00000000,%10000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000001,%00000000,%00000000,%10000000,%00000000,%01000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000001,%00000000,%00000000,%00000000,%00000000,%01000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000001,%00000000,%00000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00000000
 .db %11111111,%11111111,%11111111,%11111010,%00000000,%00000000,%00000000,%00000000,%00101111,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11111010,%00000000,%00000000,%00000000,%00000000,%00101111,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11110010,%00000000,%00000000,%00000000,%00000000,%00010111,%11111111,%11111111,%11111111
 .db %00000000,%00000000,%00000000,%00000100,%00000000,%00000000,%00000000,%00000000,%00010000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000100,%00000000,%00000000,%10000000,%00000000,%00010000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000100,%00000000,%00000000,%10000000,%00000000,%00001000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00001000,%00000000,%00000000,%10000000,%00000000,%00001000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000000,%00000000,%00000100,%00000000,%00000000,%00000000
 .db %11111111,%11111111,%11111111,%11001000,%00000000,%00000000,%00000000,%00000000,%00000100,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11010000,%00000000,%00000000,%00000000,%00000000,%00000100,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11010000,%00000000,%00000000,%00000000,%00000000,%00000010,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%10010000,%00000000,%00000000,%00000000,%00000000,%00000010,%01111111,%11111111,%11111111
 .db %00000000,%00000000,%00000000,%00100000,%00000000,%00000000,%10000000,%00000000,%00000010,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00100000,%00000000,%00000000,%10000000,%00000000,%00000001,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00100000,%00000000,%00000000,%10000000,%00000000,%00000001,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%01000000,%00000000,%00000000,%10000000,%00000000,%00000000,%10000000,%00000000,%00000000

road1
  .db %00000000,%00000000,%00000000,%00000000,%01000000,%00000000,%00000000,%00000001,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%01000000,%00000000,%00000000,%00000001,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%10000000,%00000000,%10000000,%00000000,%10000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%10000000,%00000000,%00000000,%00000000,%10000000,%00000000,%00000000,%00000000
 .db %11111111,%11111111,%11111111,%11111110,%10000000,%00000000,%00000000,%00000000,%10011111,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11111101,%00000000,%00000000,%00000000,%00000000,%01011111,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11111101,%00000000,%00000000,%00000000,%00000000,%01001111,%11111111,%11111111,%11111111
 .db %00000000,%00000000,%00000000,%00000001,%00000000,%00000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000010,%00000000,%00000000,%10000000,%00000000,%00100000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000010,%00000000,%00000000,%10000000,%00000000,%00100000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000010,%00000000,%00000000,%00000000,%00000000,%00010000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000100,%00000000,%00000000,%00000000,%00000000,%00010000,%00000000,%00000000,%00000000
 .db %11111111,%11111111,%11111111,%11110100,%00000000,%00000000,%00000000,%00000000,%00010011,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11110100,%00000000,%00000000,%00000000,%00000000,%00001011,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11101000,%00000000,%00000000,%10000000,%00000000,%00001001,%11111111,%11111111,%11111111
 .db %00000000,%00000000,%00000000,%00001000,%00000000,%00000000,%10000000,%00000000,%00000100,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00001000,%00000000,%00000000,%10000000,%00000000,%00000100,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00010000,%00000000,%00000000,%00000000,%00000000,%00000100,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00010000,%00000000,%00000000,%00000000,%00000000,%00000010,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00010000,%00000000,%00000000,%00000000,%00000000,%00000010,%00000000,%00000000,%00000000
 .db %11111111,%11111111,%11111111,%10100000,%00000000,%00000000,%00000000,%00000000,%00000010,%01111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%10100000,%00000000,%00000000,%00000000,%00000000,%00000001,%01111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%00100000,%00000000,%00000000,%10000000,%00000000,%00000001,%00111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%01000000,%00000000,%00000000,%10000000,%00000000,%00000000,%10111111,%11111111,%11111111

turn:
 .db %11111111,%11110010,%00000000,%00000010,%00000000,%00011000,%11111111,%11111111,%11111111,%11111111,%11111111,%11111111
 .db %11111111,%11111001,%00000000,%00000000,%00000000,%00000110,%00011111,%11111111,%11111111,%11111111,%11111111,%11111111
 .db %11111111,%11111100,%10000000,%00000000,%00000000,%00000001,%11000111,%11111111,%11111111,%11111111,%11111111,%11111111
 .db %00000000,%00000000,%01000000,%00000000,%00000000,%00000000,%00110000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00100000,%00000000,%00100000,%00000000,%00001100,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00100000,%00000000,%00010000,%00000000,%00000010,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00010000,%00000000,%00000000,%00000000,%00000001,%10000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00001000,%00000000,%00000000,%00000000,%00000000,%01100000,%00000000,%00000000,%00000000,%00000000
 .db %11111111,%11111111,%11001000,%00000000,%00000000,%00000000,%00000000,%00010011,%11111111,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11100100,%00000000,%00000000,%00000000,%00000000,%00001001,%11111111,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11110100,%00000000,%00000000,%00000000,%00000000,%00000100,%11111111,%11111111,%11111111,%11111111
 .db %00000000,%00000000,%00000010,%00000000,%00000000,%00000000,%00000000,%00000010,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000010,%00000000,%00000000,%00000000,%00000000,%00000001,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000001,%00000000,%00000000,%00000000,%00000000,%00000000,%10000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000001,%00000000,%00000000,%00100000,%00000000,%00000000,%01000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000001,%00000000,%00000000,%00010000,%00000000,%00000000,%00100000,%00000000,%00000000,%00000000
 .db %11111111,%11111111,%11111100,%10000000,%00000000,%00001000,%00000000,%00000000,%00100111,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111110,%10000000,%00000000,%00001000,%00000000,%00000000,%00010011,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111110,%10000000,%00000000,%00000000,%00000000,%00000000,%00001001,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111110,%10000000,%00000000,%00000000,%00000000,%00000000,%00000100,%11111111,%11111111,%11111111
 .db %00000000,%00000000,%00000000,%10000000,%00000000,%00000000,%00000000,%00000000,%00000010,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%01000000,%00000000,%00000000,%00000000,%00000000,%00000010,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%01000000,%00000000,%00000000,%00000000,%00000000,%00000001,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%01000000,%00000000,%00000000,%00000000,%00000000,%00000000,%10000000,%00000000,%00000000

turn1:
 .db %00000000,%00000010,%00000000,%00000000,%00000000,%00011000,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000001,%00000000,%00000000,%00000000,%00000110,%00000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%10000000,%00000000,%00000000,%00000001,%11000000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%01000000,%00000000,%10000000,%00000000,%00110000,%00000000,%00000000,%00000000,%00000000,%00000000
 .db %11111111,%11111111,%00100000,%00000000,%00000000,%00000000,%00001100,%11111111,%11111111,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%10100000,%00000000,%00000000,%00000000,%00000010,%00111111,%11111111,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%10010000,%00000000,%00000000,%00000000,%00000001,%10001111,%11111111,%11111111,%11111111,%11111111
 .db %00000000,%00000000,%00001000,%00000000,%00000000,%00000000,%00000000,%01100000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00001000,%00000000,%00000010,%00000000,%00000000,%00010000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000100,%00000000,%00000001,%00000000,%00000000,%00001000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000100,%00000000,%00000000,%00000000,%00000000,%00000100,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000010,%00000000,%00000000,%00000000,%00000000,%00000010,%00000000,%00000000,%00000000,%00000000
 .db %11111111,%11111111,%11111010,%00000000,%00000000,%00000000,%00000000,%00000001,%00111111,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111101,%00000000,%00000000,%00000000,%00000000,%00000000,%10011111,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111101,%00000000,%00000000,%00010000,%00000000,%00000000,%01001111,%11111111,%11111111,%11111111
 .db %00000000,%00000000,%00000001,%00000000,%00000000,%00010000,%00000000,%00000000,%00100000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%10000000,%00000000,%00001000,%00000000,%00000000,%00100000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%10000000,%00000000,%00000000,%00000000,%00000000,%00010000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%10000000,%00000000,%00000000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%10000000,%00000000,%00000000,%00000000,%00000000,%00000100,%00000000,%00000000,%00000000
 .db %11111111,%11111111,%11111110,%10000000,%00000000,%00000010,%00000000,%00000000,%00000010,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111110,%01000000,%00000000,%00000010,%00000000,%00000000,%00000010,%01111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%01000000,%00000000,%00000001,%00000000,%00000000,%00000001,%00111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%01000000,%00000000,%00000001,%00000000,%00000000,%00000000,%10011111,%11111111,%11111111

turnr1:
  .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%00011000,%00000000,%00000000,%00000000,%01000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000000,%01100000,%00000000,%00000000,%00000000,%10000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00000011,%10000000,%00000000,%00000000,%00000001,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00001100,%00000000,%00000001,%00000000,%00000010,%00000000,%00000000
 .db %11111111,%11111111,%11111111,%11111111,%11111111,%00110000,%00000000,%00000000,%00000000,%00000100,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11111111,%11111100,%01000000,%00000000,%00000000,%00000000,%00000101,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11111111,%11110001,%10000000,%00000000,%00000000,%00000000,%00001001,%11111111,%11111111
 .db %00000000,%00000000,%00000000,%00000000,%00000110,%00000000,%00000000,%00000000,%00000000,%00010000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00001000,%00000000,%00000000,%01000000,%00000000,%00010000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00010000,%00000000,%00000000,%10000000,%00000000,%00100000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00000000,%00000000,%00100000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%01000000,%00000000,%00000000,%00000000,%00000000,%01000000,%00000000,%00000000
 .db %11111111,%11111111,%11111111,%11111100,%10000000,%00000000,%00000000,%00000000,%00000000,%01011111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11111001,%00000000,%00000000,%00000000,%00000000,%00000000,%10111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11110010,%00000000,%00000000,%00001000,%00000000,%00000000,%10111111,%11111111,%11111111
 .db %00000000,%00000000,%00000000,%00000100,%00000000,%00000000,%00001000,%00000000,%00000000,%10000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000100,%00000000,%00000000,%00010000,%00000000,%00000001,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00001000,%00000000,%00000000,%00000000,%00000000,%00000001,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00010000,%00000000,%00000000,%00000000,%00000000,%00000001,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00100000,%00000000,%00000000,%00000000,%00000000,%00000001,%00000000,%00000000,%00000000
 .db %11111111,%11111111,%11111111,%01000000,%00000000,%00000000,%01000000,%00000000,%00000001,%01111111,%11111111,%11111111
 .db %11111111,%11111111,%11111110,%01000000,%00000000,%00000000,%01000000,%00000000,%00000010,%01111111,%11111111,%11111111
 .db %11111111,%11111111,%11111100,%10000000,%00000000,%00000000,%10000000,%00000000,%00000010,%11111111,%11111111,%11111111
 .db %11111111,%11111111,%11111001,%00000000,%00000000,%00000000,%10000000,%00000000,%00000010,%11111111,%11111111,%11111111

turnr:
  .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111111,%00011000,%00000000,%01000000,%00000000,%01001111,%11111111
 .db %11111111,%11111111,%11111111,%11111111,%11111111,%11111000,%01100000,%00000000,%00000000,%00000000,%10011111,%11111111
 .db %11111111,%11111111,%11111111,%11111111,%11111111,%11100011,%10000000,%00000000,%00000000,%00000001,%00111111,%11111111
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00001100,%00000000,%00000000,%00000000,%00000010,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%00110000,%00000000,%00000100,%00000000,%00000100,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000,%01000000,%00000000,%00001000,%00000000,%00000100,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000001,%10000000,%00000000,%00000000,%00000000,%00001000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000110,%00000000,%00000000,%00000000,%00000000,%00010000,%00000000,%00000000
 .db %11111111,%11111111,%11111111,%11111111,%11001000,%00000000,%00000000,%00000000,%00000000,%00010011,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11111111,%10010000,%00000000,%00000000,%00000000,%00000000,%00100111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11111111,%00100000,%00000000,%00000000,%00000000,%00000000,%00101111,%11111111,%11111111
 .db %00000000,%00000000,%00000000,%00000000,%01000000,%00000000,%00000000,%00000000,%00000000,%01000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%10000000,%00000000,%00000000,%00000000,%00000000,%01000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000001,%00000000,%00000000,%00000000,%00000000,%00000000,%10000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000010,%00000000,%00000000,%00000100,%00000000,%00000000,%10000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000100,%00000000,%00000000,%00001000,%00000000,%00000000,%10000000,%00000000,%00000000
 .db %11111111,%11111111,%11111111,%11100100,%00000000,%00000000,%00010000,%00000000,%00000001,%00111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%11001000,%00000000,%00000000,%00010000,%00000000,%00000001,%01111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%10010000,%00000000,%00000000,%00000000,%00000000,%00000001,%01111111,%11111111,%11111111
 .db %11111111,%11111111,%11111111,%00100000,%00000000,%00000000,%00000000,%00000000,%00000001,%01111111,%11111111,%11111111
 .db %00000000,%00000000,%00000000,%01000000,%00000000,%00000000,%00000000,%00000000,%00000001,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%01000000,%00000000,%00000000,%00000000,%00000000,%00000010,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%10000000,%00000000,%00000000,%00000000,%00000000,%00000010,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000001,%00000000,%00000000,%00000000,%00000000,%00000000,%00000010,%00000000,%00000000,%00000000

gover:
   .db %01110011,%00011100,%11100011,%00100101,%11011100
 .db %10000100,%10101010,%10000100,%10100101,%00010010
 .db %10000100,%10101010,%11100100,%10100101,%11010010
 .db %10110111,%10101010,%10000100,%10101001,%00011100
 .db %10010100,%10101010,%11111100,%10101001,%00010100
 .db %01110100,%10101111,%11111111,%00110001,%11010010
 .db %00000000,%00011111,%11111111,%11000000,%00000000
 .db %00000000,%01111111,%11111111,%11110000,%00000000
 .db %00000000,%11111111,%01011101,%11111000,%00000000
 .db %11111111,%11111110,%11100110,%11111111,%11111111
 .db %01100000,%00000011,%11100111,%10000000,%00000000
 .db %00011000,%00001111,%10011101,%11100111,%11111111
 .db %11111110,%00010101,%10011011,%10011111,%01111111
 .db %11111111,%11111110,%01100110,%11100110,%11100000
 .db %00000000,%11100010,%01101110,%01111110,%01000000
 .db %11111101,%10100001,%10011001,%10011111,%10111111
 .db %11110111,%01110000,%01110101,%10011011,%01111111
 .db %00000100,%00001000,%00001110,%01100100,%11000000
 .db %00000000,%00000100,%00000001,%01111000,%00100000
 .db %11111111,%11111100,%00000000,%00000000,%00011111
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000

moscr:
   .db %00000000,%00000000,%00000000,%00100000,%00000000
 .db %00000000,%00000000,%00000000,%01110000,%00000000
 .db %00000000,%00000000,%00000000,%00100000,%01000000
 .db %00000000,%00000000,%00100000,%00100000,%01000000
 .db %00000000,%00000000,%00100000,%00100000,%01000000
 .db %00000000,%00000000,%00100000,%01110000,%01000000
 .db %00000000,%00000000,%00100000,%01110000,%10100000
 .db %00000000,%01000000,%00100000,%11111001,%11110000
 .db %00000000,%01000000,%01110001,%11111110,%11101000
 .db %00000000,%01000000,%11111100,%11001011,%01010000
 .db %00000000,%01000000,%11011100,%11111011,%10101000
 .db %00000001,%01100001,%11100110,%11111001,%11110000
 .db %00000000,%11110001,%11111110,%11011100,%00110000
 .db %00000000,%01110000,%11111100,%10111101,%11100000
 .db %00000111,%11111000,%00000001,%11111101,%10110000
 .db %00000111,%11111000,%11111101,%01111111,%11111000
 .db %00000011,%11110000,%11111110,%11111111,%11111000
 .db %00000001,%11100001,%11111111,%11111110,%11111000
 .db %00000001,%11110001,%11111111,%10001111,%11111100
 .db %00000111,%11111001,%11100011,%11111110,%11111100
 .db %00000111,%11111111,%11111111,%11111101,%11101100
 .db %00011110,%11111111,%11111111,%11111011,%11111010
 .db %01111111,%11111111,%10001111,%11111111,%01111110
 .db %01111111,%11111111,%11111111,%11110111,%11111111


beijr:
 .db %00000000,%00000000,%11110000,%00000000,%00000000
 .db %00000000,%00000001,%00001000,%00000000,%00000000
 .db %00000000,%00111100,%00000100,%00000000,%00001000
 .db %00000000,%01000010,%00000100,%00000000,%00000000
 .db %00001111,%00000101,%10000000,%00000000,%00001000
 .db %00010001,%10000001,%01001000,%00000000,%00000000
 .db %00100001,%11101011,%01110000,%00000000,%00001000
 .db %00100011,%01010100,%00100000,%00000000,%00000000
 .db %00100100,%11111000,%00101110,%11101110,%11101000
 .db %00100100,%10001100,%00100010,%10101010,%10100000
 .db %00011111,%00010011,%11001110,%10101010,%11101000
 .db %00000100,%00010000,%00001000,%10101010,%10100000
 .db %00000010,%00111111,%11001110,%11101110,%11101000
 .db %00000001,%11010101,%01000000,%00000011,%00011100
 .db %00000000,%01101111,%11100011,%11000001,%10111110
 .db %00000000,%11010101,%11111111,%11111011,%01011111
 .db %00000011,%11111111,%11110000,%00110110,%10111111
 .db %00001111,%11010101,%01110101,%01111101,%10100111
 .db %00111101,%01111111,%11110000,%11111001,%11110111
 .db %11101111,%01011101,%01110101,%01110111,%10111100
 .db %01000110,%11111110,%11110000,%11111111,%11000011
 .db %00110111,%11110101,%01110101,%11011011,%10001110
 .db %10111111,%11111111,%11110001,%10110010,%10101110
 .db %11111111,%11111111,%11110101,%11111100,%01111111



tokyr:
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000010,%11111000,%00000000,%00000011,%00000000
 .db %00000111,%10111111,%00000000,%00000011,%11000000
 .db %00000100,%00010111,%10000000,%00000110,%01000000
 .db %00000110,%10010001,%10000000,%00000110,%01100000
 .db %00000111,%11100100,%00000000,%00000100,%00100000
 .db %00000101,%00001111,%11000011,%11001110,%00101000
 .db %00000100,%10011100,%01100110,%01101000,%00010000
 .db %00000101,%10100101,%10111101,%11010000,%11000000
 .db %00000111,%10100111,%10111111,%11111000,%11100100
 .db %00000101,%00100100,%01101110,%10111001,%11110000
 .db %00000100,%10101100,%01111011,%11111111,%00101000
 .db %00000110,%01101100,%01111011,%11111011,%11111000
 .db %00000101,%11110111,%11111111,%00100101,%11110100
 .db %00000100,%10101111,%11011011,%11111111,%11101100
 .db %00000111,%00111110,%01110110,%01110011,%11111110
 .db %00000111,%01111111,%01111111,%01011101,%00110110
 .db %00011111,%00111000,%11100011,%01011100,%01111010
 .db %00011001,%00101111,%11111111,%11110010,%01011100
 .db %01110101,%11111011,%00111110,%00111111,%11110101
 .db %01111111,%10101111,%01111110,%10101101,%00010111
 .db %11111000,%01111011,%11000111,%10001111,%11110111


sydnr:
  .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%11110000
 .db %00000000,%00000000,%00000000,%00000001,%10111000
 .db %00000000,%00000000,%00000000,%00000001,%11111000
 .db %00000000,%00010000,%00000000,%00000011,%01111000
 .db %00000000,%00101000,%00000000,%00000011,%11011000
 .db %00010000,%01000100,%00000000,%00000011,%01111100
 .db %00001100,%01000100,%00000000,%00010111,%10101100
 .db %00000101,%01010010,%00111100,%01111011,%11111110
 .db %00001010,%10001001,%01000010,%11010101,%01001010
 .db %00001110,%01010101,%10010000,%00010101,%11111110
 .db %00000010,%00101101,%00000000,%00100110,%11111110
 .db %00011011,%10000100,%10000100,%01110110,%01111110
 .db %00100100,%11010000,%00000011,%01010001,%00110010
 .db %01001010,%01010000,%01011111,%01001011,%10011110
 .db %10111110,%00000111,%11111111,%11011111,%10010100
 .db %01111111,%01111111,%11100100,%10010001,%11000000
 .db %00011000,%11111001,%00110011,%11111111,%11100011
 .db %01011111,%11000110,%10111011,%00001000,%00001000
 .db %01000011,%01110001,%00110001,%11111111,%11000100



cairr:
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%00000001,%00000000,%00000000
 .db %00000000,%01100000,%00000001,%10000000,%00000000
 .db %00000000,%10110000,%00000011,%01000000,%00000000
 .db %00000000,%10011000,%00000101,%01100000,%00000000
 .db %00000001,%00101100,%00000101,%10110000,%00000000
 .db %00000011,%00111110,%00001000,%10001000,%00000000
 .db %00000110,%00111001,%00010000,%11001100,%00000000
 .db %00000110,%00011110,%10100000,%11000110,%00000000
 .db %00001100,%01111111,%01101010,%11100111,%00000101
 .db %00011010,%00111110,%11000000,%01110111,%11000000
 .db %00011000,%10111111,%10000010,%00110011,%11010000
 .db %00110001,%00101111,%00110000,%00010100,%11100010
 .db %01100101,%00111110,%00010000,%00011001,%11110110
 .db %01100010,%10101100,%01000101,%00001001,%00010000
 .db %00010100,%01111100,%01001010,%00001001,%11110000
 .db %01000001,%00110100,%00000000,%00001101,%01100100
 .db %00000000,%10011001,%00100001,%00001100,%00000100
 .db %00100010,%00001110,%10101000,%00111100,%11000000


londr:
 .db %00000000,%00100000,%00000000,%00000000,%00000000
 .db %00000000,%00110000,%00000000,%00000000,%00000010
 .db %00000000,%01111000,%00000010,%00000000,%00000000
 .db %00100000,%01111000,%00000110,%00000110,%00100100
 .db %00000010,%11001100,%10000000,%00000001,%01001000
 .db %00000100,%10110100,%01100000,%01110000,%00000000
 .db %00010100,%10100100,%00000000,%11000001,%00000000
 .db %00000100,%11001100,%00000000,%00000000,%00000000
 .db %00100001,%11111110,%10000100,%00100000,%00001000
 .db %00000000,%11101100,%00001000,%00000000,%00011000
 .db %00100000,%11101100,%00000000,%00000001,%00011000
 .db %00000000,%10111100,%00000000,%00000001,%10011100
 .db %00000100,%11101100,%00100000,%10000010,%10111100
 .db %00000000,%11101101,%00100100,%10010010,%01010110
 .db %00000000,%10111111,%11111111,%11111100,%11110010
 .db %00000000,%11111001,%00111111,%11011110,%01001010
 .db %00000000,%10101111,%11110111,%11111110,%10110100
 .db %00000001,%10110000,%00000000,%00000101,%01111010
 .db %00000000,%11101111,%11111111,%11111010,%11111101
 .db %00000001,%11111111,%11111111,%11110111,%11111111
 .db %00000001,%11100000,%00001111,%11111110,%11111110
 .db %00010001,%11101011,%10111100,%10001100,%01111010
 .db %00111011,%10111011,%11101111,%11111101,%01111011
 .db %00111111,%11111111,%11011111,%11111101,%01111011



parir:
   .db %00000000,%00000000,%10000000,%00000000,%00000000
 .db %00000000,%00000000,%00000000,%00000000,%00000000
 .db %00000000,%00000000,%10000000,%00000000,%01000000
 .db %00100000,%01100000,%10000000,%00000000,%00000100
 .db %00000010,%00000000,%10000000,%11000110,%00000100
 .db %00000000,%00000001,%01000000,%00000000,%00000000
 .db %00000000,%00000001,%11000000,%00110000,%00000000
 .db %00000000,%01000001,%01000000,%00000000,%00000000
 .db %00000010,%00000011,%11100000,%10000000,%00010000
 .db %00000000,%00000011,%01100000,%01000001,%00000000
 .db %00000000,%00001111,%11111000,%00000000,%00000000
 .db %00000000,%00001111,%11111000,%00000000,%00000000
 .db %00000000,%00000110,%00110000,%00000000,%00000000
 .db %00000000,%00000110,%00110000,%00000000,%00000000
 .db %00000000,%00001100,%00011000,%00000000,%00000000
 .db %00100000,%00001100,%00011000,%00000000,%00000000
 .db %00011000,%00011100,%00011000,%00000000,%00000110
 .db %01111000,%01111111,%11111111,%00000100,%00001110
 .db %11001000,%00101111,%11111110,%00001111,%10011001
 .db %11101000,%01110101,%01010101,%00001001,%01001001
 .db %11101110,%01011111,%11111111,%00011111,%11101110
 .db %11111110,%10111000,%00001110,%10001011,%11111110
 .db %00110110,%11110000,%00000111,%10100110,%01111110
 .db %11011110,%10110000,%00000110,%10101111,%01111110


nyr:
  .db %00000100,%00000000,%00000000,%01000000,%00000000
 .db %00001100,%00000001,%00000000,%00100010,%00000000
 .db %00001100,%01000000,%00100100,%10001000,%01000100
 .db %00100101,%01010010,%00101100,%01000110,%10000100
 .db %00000110,%11000000,%10000010,%00001001,%10000000
 .db %00000101,%10010000,%00110000,%00100000,%00100000
 .db %00000100,%10000001,%10000101,%00001001,%00001100
 .db %01001100,%11000110,%00001000,%00100000,%00000000
 .db %00001011,%10100000,%01010010,%00000010,%00100000
 .db %00000111,%01010000,%01000000,%10000000,%00000000
 .db %00000010,%00010000,%10111101,%11111111,%11111110
 .db %01010101,%01110000,%00101010,%10101000,%00000000
 .db %00000100,%00101000,%00110101,%01011111,%11111110
 .db %10000010,%01011001,%10101010,%10101000,%00000000
 .db %01100111,%00001000,%00110101,%01011111,%11111110
 .db %00000110,%10001000,%00101010,%10101000,%00000000
 .db %00001011,%00110010,%10111111,%11111111,%11111110
 .db %00000111,%00110000,%00000000,%00000000,%00000001
 .db %00001010,%01110000,%00111111,%11111111,%00000110
 .db %00000110,%00101000,%00000000,%01111010,%11011101
 .db %00001101,%10011000,%00111111,%01110100,%01110000
 .db %00001101,%10100110,%00000000,%10011011,%10101110
 .db %00011111,%11111110,%00111111,%01111111,%11111110
 .db %00110111,%00111011,%00000011,%00111101,%11000000







END








